<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: matrix_lu.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_571b715927b0d4b7bee37d60dac387ec.html">matrix</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">matrix_lu.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2009  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// This code was adapted from code from the JAMA part of NIST&#39;s TNT library.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//    See: http://math.nist.gov/tnt/ </span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#ifndef DLIB_MATRIX_LU_DECOMPOSITION_H</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define DLIB_MATRIX_LU_DECOMPOSITION_H</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;matrix.h&quot;</span> </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;matrix_utilities.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;matrix_subexp.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;matrix_trsm.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#ifdef DLIB_USE_LAPACK </span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;lapack/getrf.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a> </div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keyword">typename</span> matrix_exp_type</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        &gt;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classdlib_1_1lu__decomposition.html">   25</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1lu__decomposition.html">lu_decomposition</a></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NR = matrix_exp_type::NR;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> NC = matrix_exp_type::NC;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::type type;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_exp_type::layout_type layout_type;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keyword">typedef</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;type,0,0,mem_manager_type,layout_type&gt;</a>  <a class="code" href="classdlib_1_1matrix.html">matrix_type</a>;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">typedef</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;type,NR,1,mem_manager_type,layout_type&gt;</a> <a class="code" href="classdlib_1_1matrix.html">column_vector_type</a>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">typedef</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;long,NR,1,mem_manager_type,layout_type&gt;</a> <a class="code" href="classdlib_1_1matrix.html">pivot_column_vector_type</a>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="comment">// You have supplied an invalid type of matrix_exp_type.  You have</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="comment">// to use this object with matrices that contain float or double type data.</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        COMPILE_TIME_ASSERT((<a class="code" href="classdlib_1_1is__same__type.html">is_same_type&lt;float, type&gt;::value</a> || </div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                             <a class="code" href="classdlib_1_1is__same__type.html">is_same_type&lt;double, type&gt;::value</a> ));</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <a class="code" href="classdlib_1_1lu__decomposition.html">lu_decomposition</a> (</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html">matrix_exp&lt;EXP&gt;</a> &amp;A</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        );</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordtype">bool</span> is_square (</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordtype">bool</span> is_singular (</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keywordtype">long</span> nr(</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordtype">long</span> nc(</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix_type</a> get_l (</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix_type</a> get_u (</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">pivot_column_vector_type</a>&amp; get_pivot (</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        type det (</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix_type</a> solve (</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html">matrix_exp&lt;EXP&gt;</a> &amp;B</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="comment">/* Array for internal storage of decomposition.  */</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;type,0,0,mem_manager_type,column_major_layout&gt;</a>  LU;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordtype">long</span> m, n, pivsign; </div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">pivot_column_vector_type</a> piv;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    }; </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">//                              Public member functions</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <a class="code" href="classdlib_1_1lu__decomposition.html">lu_decomposition&lt;matrix_exp_type&gt;::</a></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<a class="code" href="classdlib_1_1lu__decomposition.html">    lu_decomposition</a> (</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix__exp.html">matrix_exp&lt;EXP&gt;</a>&amp; A</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    ) : </div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        LU(A),</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        m(A.nr()),</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        n(A.nc())</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keyword">using</span> std::abs;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        COMPILE_TIME_ASSERT((<a class="code" href="classdlib_1_1is__same__type.html">is_same_type&lt;type, typename EXP::type&gt;::value</a>));</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        DLIB_ASSERT(A.size() &gt; 0,</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="stringliteral">&quot;\tlu_decomposition::lu_decomposition(A)&quot;</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tInvalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tA.size(): &quot;</span> &lt;&lt; A.size()</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tthis:     &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            );</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="preprocessor">#ifdef DLIB_USE_LAPACK</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;lapack::integer,0,1,mem_manager_type,layout_type&gt;</a> piv_temp;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        lapack::getrf(LU, piv_temp);</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        pivsign = 1;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="comment">// Turn the piv_temp vector into a more useful form.  This way we will have the identity</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="comment">// rowm(A,piv) == L*U.  The permutation vector that comes out of LAPACK is somewhat</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="comment">// different.</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        piv = trans(range(0,m-1));</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; piv_temp.size(); ++i)</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        {</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <span class="comment">// -1 because FORTRAN is indexed starting with 1 instead of 0</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            <span class="keywordflow">if</span> (piv(piv_temp(i)-1) != piv(i))</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            {</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;                std::swap(piv(i), piv(piv_temp(i)-1));</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;                pivsign = -pivsign;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            }</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        }</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="comment">// Use a &quot;left-looking&quot;, dot-product, Crout/Doolittle algorithm.</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160; </div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        piv = trans(range(0,m-1));</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        pivsign = 1;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        column_vector_type LUcolj(m);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="comment">// Outer loop.</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; n; j++) </div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        {</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="comment">// Make a copy of the j-th column to localize references.</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            LUcolj = colm(LU,j);</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="comment">// Apply previous transformations.</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; m; i++) </div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            {</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                <span class="comment">// Most of the time is spent in the following dot product.</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                <span class="keyword">const</span> <span class="keywordtype">long</span> kmax = std::min(i,j);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                type s;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                <span class="keywordflow">if</span> (kmax &gt; 0)</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;                    s = rowm(LU,i, kmax)*colm(LUcolj,0,kmax);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                <span class="keywordflow">else</span> </div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                    s = 0;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                LU(i,j) = LUcolj(i) -= s;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            }</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            <span class="comment">// Find pivot and exchange if necessary.</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            <span class="keywordtype">long</span> p = j;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = j+1; i &lt; m; i++) </div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                <span class="keywordflow">if</span> (abs(LUcolj(i)) &gt; abs(LUcolj(p))) </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                {</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                    p = i;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;                }</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            }</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            <span class="keywordflow">if</span> (p != j) </div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;            {</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                <span class="keywordtype">long</span> k=0;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                <span class="keywordflow">for</span> (k = 0; k &lt; n; k++) </div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                {</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;                    type t = LU(p,k); </div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;                    LU(p,k) = LU(j,k); </div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                    LU(j,k) = t;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;                }</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                k = piv(p); </div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                piv(p) = piv(j); </div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                piv(j) = k;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                pivsign = -pivsign;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            }</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            <span class="comment">// Compute multipliers.</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            <span class="keywordflow">if</span> ((j &lt; m) &amp;&amp; (LU(j,j) != 0.0)) </div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            {</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = j+1; i &lt; m; i++) </div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                {</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                    LU(i,j) /= LU(j,j);</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                }</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            }</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        }</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    }</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160; </div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160; </div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordtype">bool</span> lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    is_square (</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        <span class="keywordflow">return</span> m == n;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    }</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160; </div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160; </div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="keywordtype">long</span> lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    nr (</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keywordflow">return</span> m;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    }</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160; </div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160; </div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordtype">long</span> lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    nc (</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="keywordflow">return</span> n;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    }</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160; </div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160; </div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    <span class="keywordtype">bool</span> lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    is_singular (</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="comment">/* Is the matrix singular?</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">          if upper triangular factor U (and hence A) is singular, false otherwise.</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="comment">        */</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        DLIB_ASSERT(is_square() == <span class="keyword">true</span>,</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            <span class="stringliteral">&quot;\tbool lu_decomposition::is_singular()&quot;</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tYou can only use this on square matrices&quot;</span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            );</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160; </div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        type max_val, min_val;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        find_min_and_max (abs(diag(LU)), min_val, max_val);</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        type eps = max_val;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keywordflow">if</span> (eps != 0)</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            eps *= std::sqrt(std::numeric_limits&lt;type&gt;::epsilon())/10;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            eps = 1;  <span class="comment">// there is no max so just use 1</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160; </div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keywordflow">return</span> min_val &lt; eps;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    }</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160; </div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160; </div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keyword">const</span> <span class="keyword">typename</span> lu_decomposition&lt;matrix_exp_type&gt;::matrix_type lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    get_l (</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keywordflow">if</span> (LU.nr() &gt;= LU.nc())</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            <span class="keywordflow">return</span> lowerm(LU,1.0);</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            <span class="keywordflow">return</span> lowerm(subm(LU,0,0,m,m), 1.0);</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    }</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160; </div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160; </div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    <span class="keyword">const</span> <span class="keyword">typename</span> lu_decomposition&lt;matrix_exp_type&gt;::matrix_type lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    get_u (</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    )<span class="keyword"> const </span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        <span class="keywordflow">if</span> (LU.nr() &gt;= LU.nc())</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            <span class="keywordflow">return</span> upperm(subm(LU,0,0,n,n));</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="keywordflow">return</span> upperm(LU);</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    }</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160; </div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160; </div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    <span class="keyword">const</span> <span class="keyword">typename</span> lu_decomposition&lt;matrix_exp_type&gt;::pivot_column_vector_type&amp; lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    get_pivot (</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keywordflow">return</span> piv;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    }</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160; </div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160; </div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    <span class="keyword">typename</span> lu_decomposition&lt;matrix_exp_type&gt;::type lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    det (</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        DLIB_ASSERT(is_square() == <span class="keyword">true</span>,</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;            <span class="stringliteral">&quot;\ttype lu_decomposition::det()&quot;</span></div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tYou can only use this on square matrices&quot;</span></div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;            );</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160; </div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        <span class="comment">// Check if it is singular and if it is just return 0.  </span></div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="comment">// We want to do this because a prod() operation can easily</span></div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="comment">// overcome a single diagonal element that is effectively 0 when</span></div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="comment">// LU is a big enough matrix.</span></div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="keywordflow">if</span> (is_singular())</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;            <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160; </div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keywordflow">return</span> prod(diag(LU))*static_cast&lt;type&gt;(pivsign);</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    }</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160; </div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160; </div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_exp_type&gt;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> EXP&gt;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <span class="keyword">const</span> <span class="keyword">typename</span> lu_decomposition&lt;matrix_exp_type&gt;::matrix_type lu_decomposition&lt;matrix_exp_type&gt;::</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    solve (</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt; &amp;B</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    )<span class="keyword"> const</span></div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        COMPILE_TIME_ASSERT((is_same_type&lt;type, typename EXP::type&gt;::value));</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160; </div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        DLIB_ASSERT(is_square() == <span class="keyword">true</span> &amp;&amp; B.nr() == nr(),</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;            <span class="stringliteral">&quot;\ttype lu_decomposition::solve()&quot;</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tInvalid arguments to this function&quot;</span></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tis_square():   &quot;</span> &lt;&lt; (is_square()? <span class="stringliteral">&quot;true&quot;</span>:<span class="stringliteral">&quot;false&quot;</span> )</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tB.nr():        &quot;</span> &lt;&lt; B.nr() </div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tnr():          &quot;</span> &lt;&lt; nr() </div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\tthis:          &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            );</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160; </div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="comment">// Copy right hand side with pivoting</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        matrix&lt;type,0,0,mem_manager_type,column_major_layout&gt; X(rowm(B, piv));</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160; </div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        <span class="keyword">using namespace </span>blas_bindings;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        <span class="comment">// Solve L*Y = B(piv,:)</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        triangular_solver(CblasLeft, CblasLower, CblasNoTrans, CblasUnit, LU, X);</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        <span class="comment">// Solve U*X = Y;</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        triangular_solver(CblasLeft, CblasUpper, CblasNoTrans, CblasNonUnit, LU, X);</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        <span class="keywordflow">return</span> X;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160; </div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160; </div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;} </div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160; </div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="preprocessor">#endif // DLIB_MATRIX_LU_DECOMPOSITION_H </span></div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160; </div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1lu__decomposition_html"><div class="ttname"><a href="classdlib_1_1lu__decomposition.html">dlib::lu_decomposition</a></div><div class="ttdef"><b>Definition:</b> matrix_lu.h:25</div></div>
<div class="ttc" id="aclassdlib_1_1matrix_html"><div class="ttname"><a href="classdlib_1_1matrix.html">dlib::matrix&lt; type, 0, 0, mem_manager_type, layout_type &gt;</a></div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<div class="ttc" id="aclassdlib_1_1matrix__exp_html"><div class="ttname"><a href="classdlib_1_1matrix__exp.html">dlib::matrix_exp</a></div><div class="ttdef"><b>Definition:</b> matrix_assign_fwd.h:67</div></div>
<div class="ttc" id="aclassdlib_1_1is__same__type_html"><div class="ttname"><a href="classdlib_1_1is__same__type.html">dlib::is_same_type</a></div><div class="ttdef"><b>Definition:</b> algs.h:431</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
